function varargout = nidaq_gui(varargin)
% NIDAQ_GUI M-file for nidaq_gui.fig
%      NIDAQ_GUI, by itself, creates a new NIDAQ_GUI or raises the existing
%      singleton*.
%
%      H = NIDAQ_GUI returns the handle to a new NIDAQ_GUI or the handle to
%      the existing singleton*.
%
%      NIDAQ_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NIDAQ_GUI.M with the given input arguments.
%
%      NIDAQ_GUI('Property','Value',...) creates a new NIDAQ_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before nidaq_gui_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to nidaq_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help nidaq_gui

% Last Modified by GUIDE v2.5 03-Nov-2005 23:01:05

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @nidaq_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @nidaq_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before nidaq_gui is made visible.
function nidaq_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to nidaq_gui (see VARARGIN)

% Choose default command line output for nidaq_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes nidaq_gui wait for user response (see UIRESUME)
% uiwait(handles.nidaqgui);


% --- Outputs from this function are returned to the command line.
function varargout = nidaq_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in exportbutton.
function exportbutton_Callback(hObject, eventdata, handles)
% hObject    handle to exportbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
userd = get(gcf,'Userdata');
t = userd(:,1);
X = userd(:,2:end);
assignin('base','t',t);
assignin('base','X',X);

% --- Executes on button press in savebutton.
function savebutton_Callback(hObject, eventdata, handles)
% hObject    handle to savebutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname] = uiputfile('*.mat', 'Save data as...');
userd = get(gcf,'UserData');
t = userd(:,1);
X = userd(:,2:end);
if pathname~=0,
    eval(['save ''',pathname,filename,''' t X;']);
end;

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close(gcf);


function sampedit_Callback(hObject, eventdata, handles)
% hObject    handle to sampedit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sampedit as text
%        str2double(get(hObject,'String')) returns contents of sampedit
%        as a double


% --- Executes during object creation, after setting all properties.
function sampedit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sampedit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in startbutton.
function startbutton_Callback(hObject, eventdata, handles)
% hObject    handle to startbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
Fs = str2double(get(findobj('tag','sampedit'),'string'));
T = str2double(get(findobj('tag','durationedit'),'string'));
ch = (find(cell2mat(get(sort(findobj('style','checkbox')),'value'))==1)-1)';
[t,X] = catchnidaq(ch,Fs,T);
userd = [t,X];
set(gcf,'Userdata',userd);

function durationedit_Callback(hObject, eventdata, handles)
% hObject    handle to durationedit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of durationedit as text
%        str2double(get(hObject,'String')) returns contents of durationedit as a double


% --- Executes during object creation, after setting all properties.
function durationedit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to durationedit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in ch0.
function ch0_Callback(hObject, eventdata, handles)
% hObject    handle to ch0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch0


% --- Executes on button press in ch1.
function ch1_Callback(hObject, eventdata, handles)
% hObject    handle to ch1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch1


% --- Executes on button press in ch2.
function ch2_Callback(hObject, eventdata, handles)
% hObject    handle to ch2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch2


% --- Executes on button press in ch3.
function ch3_Callback(hObject, eventdata, handles)
% hObject    handle to ch3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch3


% --- Executes on button press in ch4.
function ch4_Callback(hObject, eventdata, handles)
% hObject    handle to ch4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch4


% --- Executes on button press in ch5.
function ch5_Callback(hObject, eventdata, handles)
% hObject    handle to ch5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch5


% --- Executes on button press in ch6.
function ch6_Callback(hObject, eventdata, handles)
% hObject    handle to ch6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch6


% --- Executes on button press in ch7.
function ch7_Callback(hObject, eventdata, handles)
% hObject    handle to ch7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch7


% --- Executes on button press in ch8.
function ch8_Callback(hObject, eventdata, handles)
% hObject    handle to ch8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch8


% --- Executes on button press in ch9.
function ch9_Callback(hObject, eventdata, handles)
% hObject    handle to ch9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ch9


% --- Executes during object creation, after setting all properties.
function nidaqgui_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nidaqgui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
set(gcf,'userdata',[0,0]);



% --- Executes during object creation, after setting all properties.
function startbutton_CreateFcn(hObject, eventdata, handles)
% hObject    handle to startbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


